pro ghostRotateX,event
widget_control, event.top,get_uvalue=statePtr
;only want to rotate by the difference from the last one
(*statePtr).oGroup->rotate,[1,0,0],(event.value-(*statePtr).oldX)
(*statePtr).oWindow->Draw, (*statePtr).oView
(*statePtr).oldX = event.value
return
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro ghostRotateY,event
widget_control, event.top,get_uvalue=statePtr
;only want to rotate by the difference from the last one
(*statePtr).oGroup->rotate,[0,1,0],(event.value-(*statePtr).oldY)
(*statePtr).oWindow->Draw, (*statePtr).oView
(*statePtr).oldY = event.value
return
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro ghostDriver_event,event
;krGhostSlider will "hijack" all the events after the
;user has clicked on the knob.  Once it has been released
;all other events will go here.
widget_control, event.top,get_uvalue=statePtr
;always have to send the event to the ghost slider
(*statePtr).oGhostSliderX->eventHandler, event,(*statePtr).oWindow, (*statePtr).oView
(*statePtr).oGhostSliderY->eventHandler, event,(*statePtr).oWindow, (*statePtr).oView
;make them appear/disappear on right mouse click
if event.press eq 4 then begin
  if (*statePtr).hide eq 1 then  (*statePtr).hide = 0 else $
  (*statePtr).hide = 1
  (*statePtr).oGhostSliderX->setProperty,hide=(*statePtr).hide
  (*statePtr).oGhostSliderY->setProperty,hide=(*statePtr).hide
  (*statePtr).oWindow->Draw, (*statePtr).oView
endif

return
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|
pro ghostCleanup,base

widget_control, base, get_uvalue=statePtr
obj_destroy, (*statePtr).oView
obj_destroy, (*statePtr).oWindow
obj_destroy, (*statePtr).oGroup
obj_destroy, (*statePtr).oGhostSliderX
obj_destroy, (*statePtr).oGhostSliderY
ptr_free,  statePtr
return
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro ghostDriver, zData

; Default surface data is a Bessel function.
IF (N_ELEMENTS(zData) EQ 0) THEN begin
  zData = BESELJ(SHIFT(DIST(40),20,20)/2,0)
  xData = findgen(40)-20
  yData = xData
endif

; Create the widgets.
wBase = WIDGET_BASE(/COLUMN, XPAD=0, YPAD=0, $
                        TITLE="Ghost Slider Example")

wDraw = WIDGET_DRAW(wBase, XSIZE=400, YSIZE=400, UVALUE='DRAW', $
                        RETAIN=0, /EXPOSE_EVENTS, /BUTTON_EVENTS, $
                        GRAPHICS_LEVEL=2)

widget_control,wBase,/realize
widget_control,wDraw,get_value=oWindow

; Create view.
 oView = OBJ_NEW('IDLgrView', PROJECTION=1, EYE=53, ZCLIP=[50,-50],$
                    VIEWPLANE_RECT=[-25,-25,50,50], COLOR=[40,40,40])

; Create model.
oTop = OBJ_NEW('IDLgrModel')
oGroup = OBJ_NEW('IDLgrModel')
oTop->Add, oGroup
;add a title
oTitle = obj_new('IDLgrText',location=[-20,20], color=[255,255,255], $
         'Right mouse click to make ghost sliders appear')
oTop ->add, oTitle

; Create the surface.
oSurface = OBJ_NEW('IDLgrSurface', zData,xData, yData, STYLE=2, SHADING=0, $
                       COLOR=[60,60,255], BOTTOM=[64,192,128])
oGroup->Add, oSurface
; Rotate to standard view for first draw.
oGroup->Rotate, [1,0,0], -90
oGroup->Rotate, [0,1,0], 30
oGroup->Rotate, [1,0,0], 30

; Create some lights.
oLight = OBJ_NEW('IDLgrLight', LOCATION=[2,2,2], TYPE=1)
oTop->Add, oLight
oLight = OBJ_NEW('IDLgrLight', TYPE=0, INTENSITY=0.5)
oTop->Add, oLight
;create the ghost slider
startX = 0.0
startY = 0.0
oGhostSliderX = obj_new('krGhostSlider',wDraw, min=-90,max=90,value=startX, color=[255,0,0], $
                        displayFormat='(f5.1)', location=[-20,-20],xsize=20,ysize = 2, $
                        hide=1,event_pro='ghostRotateX',zVal=45,title='X angle')
oGhostSliderY = obj_new('krGhostSlider',wDraw, min=-90,max=90,value=startY, color=[0,255,0], $
                        displayFormat='(i4)', location=[10,-20],xsize=2,ysize = 20, $
                        hide=1,event_pro='ghostRotateY',zVal=45,title='Y angle', $
                        vertical=1,/integer)

oTop->add, oGhostSliderX
oTop->add, oGhostSliderY

; Place the model in the view.
oView->Add, oTop
oWindow->Draw, oView

state = { oView : oView, $
          oWindow : oWindow, $
          oGroup : oGroup, $
          oGhostSliderX : oGhostSliderX, $
          oGhostSliderY : oGhostSliderY, $
          hide : 1, $
          oldX :startX, $
          oldY : startY }

widget_control, wBase, set_uvalue=ptr_new(state)

xmanager,'ghostDriver',wBase,/no_block,cleanup='ghostCleanup'

return
end
